#include "class.h"
#include "student.h"
#include <algorithm>
#include <iostream>

bool Class::hasCSN()
{
	std::vector<AbstractStudent*>::iterator it;
	for(it = Class::students.begin(); it != Class::students.end(); it++)
		if(!(*it)->hasCSN())
			return false;
	return true;
}

void Class::grantCSN()
{
	std::vector<AbstractStudent*>::iterator it;
	for(it = Class::students.begin(); it != Class::students.end(); it++)
		(*it)->grantCSN();
}

void Class::revokeCSN()
{
	std::vector<AbstractStudent*>::iterator it;
	for(it = Class::students.begin(); it != Class::students.end(); it++)
		(*it)->revokeCSN();
}

Class::Class(std::string name)
{
	Class::name = name;
}

void Class::addStudent(AbstractStudent* student)
{
	student->increaseRefCount();
	Class::students.push_back(student);
}

void Class::removeStudent(AbstractStudent* student)
{
	student->decreaseRefCount();
	std::vector<AbstractStudent*>::iterator it = std::find(Class::students.begin(),Class::students.end(), student);
	Class::students.erase(it);
	if(student->isDisposable())
		delete student;
}

Class::~Class()
{
	std::vector<AbstractStudent*>::iterator it;
	for(it = Class::students.begin(); it != Class::students.end(); it++)
	{
		(*it)->decreaseRefCount();
		if((*it)->isDisposable())
			delete (*it);
	}
	students.clear();
}

